unit PanReliefUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Spin, Registry, StdCtrls, Menus;

type
  TPanReliefInterface = class(TForm)
    sButton1: TButton;
    sLabel2: TLabel;
    RightClip: TSpinEdit;
    sLabel3: TLabel;
    sTrackBar1: TTrackBar;
    sLabel4: TLabel;
    sLabel5: TLabel;
    SpeedLabel: TLabel;
    OnlyIn640x480: TCheckBox;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    AboutPanRelief1: TMenuItem;
    Quit1: TMenuItem;
    N1: TMenuItem;
    sLabel1: TLabel;
    LeftClip: TSpinEdit;
    Label1: TLabel;
    ClipTop: TSpinEdit;
    procedure sButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sTrackBar1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Quit1Click(Sender: TObject);
    procedure AboutPanRelief1Click(Sender: TObject);
  private
    Running, Paused:Boolean;
    { Private declarations }
  public
    { Public declarations }
    procedure directExecute;
  end;

var
  PanReliefInterface: TPanReliefInterface;

implementation

{$R AsInvoker.res}

{$R *.DFM}

function PauseKeyIsDown:Boolean;
var
   KeyValue:SmallInt;
   KeyStrValue:array[1..4] of Byte;
begin
   KeyValue:=GetAsyncKeyState(VK_PAUSE);
   Move(KeyValue,KeyStrValue,4);
   Result:=KeyStrValue[2] <> 0;
end;


procedure TPanReliefInterface.DirectExecute;
var
   CurPos:TPoint;

begin
     running:=true;
     Paused:=False;
     sButton1.Caption:='Stop Pan Relief';
     repeat
       GetCursorPos(CurPos);
       if PauseKeyIsDown then
        begin
          Paused:=not Paused;
          if Paused then
             sButton1.Caption:='Paused'
          else
             sButton1.Caption:='Stop Pan Relief';
          repeat
            Application.ProcessMessages;
          until not PauseKeyIsDown;
        end;

       if not Paused and (sTrackBar1.Position > 0) AND ((CurPos.x < LeftClip.Value) or (CurPos.x > RightClip.Value)) and
          (CurPos.Y >= ClipTop.Value) and (not OnlyIn640x480.checked or (Screen.Width = 640)) then
        begin
          Sleep(100-sTrackBar1.Position);
          if CurPos.X < LeftClip.Value then
             SetCursorPos(LeftClip.Value,CurPos.y)
          else
             SetCursorPos(RightClip.Value,CurPos.y);
        end
       else
        Application.ProcessMessages;
     until not Running;
     sButton1.Caption:='Start Pan Relief';
end;


procedure TPanReliefInterface.sButton1Click(Sender: TObject);
begin
   if Running and not Paused then
      Running:=False
   else if Running and Paused then
    begin
      Paused:=false;
      sButton1.Caption:='Stop Pan Relief';
    end
   else
      DirectExecute;
end;

procedure TPanReliefInterface.FormCreate(Sender: TObject);
begin
     Running:=false;
     with TRegistry.Create() do
      begin
           RootKey:=HKEY_CURRENT_USER;
           if OpenKeyReadOnly('Software/Anti-Pan Medication') then
            begin
              try
                 sTrackBar1.Position:=ReadInteger('Pan Speed');
              except
                 sTrackBar1.Position:=50;
              end;
              try
                LeftClip.Value:=ReadInteger('Left Clip');
              except
                LeftClip.Value:=75;
              end;
              try
                RightClip.Value:=ReadInteger('Right Clip');
              except
                RightClip.Value:=565;
              end;
              try
                ClipTop.Value:=ReadInteger('Clip Top');
              except
                ClipTop.Value:=75;
              end;
              try
                 OnlyIn640x480.checked:=ReadBool('Only in 640 x 480');
              except
                 OnlyIn640x480.Checked:=True;
              end;
            end;
           CloseKey();
           Free;
      end;
     SpeedLabel.Caption:='Panning Speed: '+IntToStr(100-sTrackBar1.Position)+'%';
end;

procedure TPanReliefInterface.sTrackBar1Change(Sender: TObject);
begin
     SpeedLabel.Caption:='Panning Speed: '+IntToStr(100-sTrackBar1.Position)+'%';
end;

procedure TPanReliefInterface.FormDestroy(Sender: TObject);
begin
     with TRegistry.Create() do
      begin
           RootKey:=HKEY_CURRENT_USER;
           if OpenKey('Software/Anti-Pan Medication',true) then
           begin
              WriteInteger('Pan Speed',sTrackBar1.Position);
              WriteInteger('Left Clip',LeftClip.Value);
              WriteInteger('Right Clip',RightClip.Value);
              WriteInteger('Clip Top',ClipTop.Value);
              WriteBool('Only in 640 x 480',OnlyIn640x480.checked);
           end;
           CloseKey();
           Free;
      end;

end;

procedure TPanReliefInterface.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     Running:=False;
     Application.ProcessMessages;
     CanClose:=True;
end;

procedure TPanReliefInterface.Quit1Click(Sender: TObject);
begin
     Running:=false;
     Application.ProcessMessages;
     Close;
end;

procedure TPanReliefInterface.AboutPanRelief1Click(Sender: TObject);
begin
     MessageBox(GetActiveWindow(),'Pan Relief is hereby released as freeware'+#13+
                                  'to the "retro" gaming community so that all'+#13+
                                  'may share their favorite games with their'+#13+
                                  'children.'#13#13'Ken Schafer, author 2010',
                                  'About Pan Relief',MB_ICONINFORMATION);
end;

end.
